#include <windows.h>
#include <mmsystem.h>
#include <stdio.h>

DOUBLE casmf = 0.0f;	//cas mezi framy
FLOAT fps = 0.0f;		//pocet framu za sekundu
BOOL sek = FALSE;		//zacatek sekundy


VOID FPS() {
	static BOOL init = FALSE;
	static BOOL useQPF = FALSE;
	static DOUBLE time = 0.0, lasttime = 0.0, flasttime = 0.0;
	static LONGLONG tps = 0;
	static INT pocf = 0;

	if (!init) {
		LARGE_INTEGER TpS;
		useQPF = QueryPerformanceFrequency(&TpS);
		if (useQPF) tps = TpS.QuadPart;
		init = TRUE;
	}

	if (useQPF) {
		LARGE_INTEGER QPC;
        QueryPerformanceCounter(&QPC);
		time = (DOUBLE)QPC.QuadPart/tps;
	} else {
		time = (DOUBLE)timeGetTime()*0.001;
	}

	sek = FALSE;
	if ((time - flasttime) > 1.0) {
		fps = (FLOAT)((time - flasttime)/casmf);
		flasttime = time;
		sek = true;
	}

	casmf = time - lasttime;
	lasttime = time;
}



HRESULT Init(HWND hwnd) {

	return S_OK;
}

HRESULT Render() {
	FPS();

	return S_OK;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {
	switch (message) {
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	case WM_PAINT:
		ValidateRect(hwnd, NULL);
		InvalidateRect(hwnd, NULL, FALSE);
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
	HWND hwnd;
	MSG msg;
	WNDCLASS WndClass = {
		CS_HREDRAW | CS_VREDRAW,
		WndProc,
		0,
		0,
		hInstance,
		LoadIcon(NULL, IDI_APPLICATION),
		LoadCursor(NULL, IDC_ARROW),
		(HBRUSH) GetStockObject(WHITE_BRUSH),
		NULL,
		"Direct 3D"
	};
	if (!RegisterClass(&WndClass)) {
		MessageBox(NULL, TEXT("Tento program vyaduje Windows"), "Direct 3D", MB_ICONERROR);
		return 0;
	}
	hwnd = CreateWindow(
		"Direct 3D",
		TEXT("Test01"),
		WS_OVERLAPPEDWINDOW,
		100, 100,
		600, 600,
		NULL, NULL,
		hInstance, NULL);

	ShowWindow(hwnd, nShowCmd);
	UpdateWindow(hwnd);

	if (SUCCEEDED(Init(hwnd))) {
		BOOL gm = TRUE;
		while (gm) {
			if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
				if(gm = GetMessage(&msg, NULL, 0, 0)) {
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}
			else {
				Render();

//				for (long i = 0; i < 2000000; i ++) ;
				if (sek) {
					HDC hdc = GetDC(hwnd);
//					SetBkColor( hdc, RGB( 0, 0, 0 ) );
//					SetTextColor( hdc, RGB( 0, 0, 255 ) );
					TCHAR txt[40];
					sprintf(txt, "%f             ", fps);
					TextOut( hdc, 0, 0, txt, lstrlen(txt) );
					ReleaseDC(hwnd, hdc);
				}
			}
		}
	}

	return 1;
}
