#include <windows.h>
#include <d3dx8.h>

#include "setup.h"

#define CLASSNAME TEXT("DirectX:Direct3D")
#define APPNAME TEXT("Test02")

struct CREATEDEVICEPARAMETERS {
	UINT Adapter;
	D3DDEVTYPE DeviceType;
	DWORD BahaviorFlags;
	D3DPRESENT_PARAMETERS PParameters;
};

void CleanOther();
void CleanFinalOther();
void RestoreOther();
void RestoreD3D();
void SwapD3DDevice();
void ResizeWindow(DWORD, DWORD);
BOOL GetD3DDeviceParameters();

HINSTANCE GhInstance;
HWND Ghwnd;

LPDIRECT3D8 GlpD3D = NULL;
LPDIRECT3DDEVICE8 GlpD3DDevice = NULL;
CREATEDEVICEPARAMETERS GWndCDP, GFullCDP;
BOOL Gafull;
FLOAT GBBufferAspectRatio;
FLOAT GMonitorAspectRatio;

BOOL GPause = FALSE;
BOOL alt = FALSE;

inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
	
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	
	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_SCREENSAVE:
		case SC_MONITORPOWER:
			return 0;
		}
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE) PostQuitMessage(0);
//		if (wParam == VK_ALT) alt = TRUE;
		if (wParam == VK_RETURN) SwapD3DDevice();
		if (wParam == VK_SPACE) GPause = !GPause;
		break;

	case WM_KEYUP:
		if (wParam == VK_F1) MessageBox(Ghwnd, TEXT("Direct 3D - Test02\nAdam(c) 2002"), APPNAME, MB_ICONINFORMATION);
//		if (wParam == VK_F1) GetD3DDeviceParameters();
//		if (wParam == VK_ALT) alt = FALSE;
		break;

	case WM_SIZE:
		{
			ResizeWindow(LOWORD(lParam),HIWORD(lParam));
			return 0;
		}

	}

	return DefWindowProc(hwnd, msg, wParam, lParam);

}


HRESULT CreateD3DDevice(CREATEDEVICEPARAMETERS *cdp) {
	return GlpD3D->CreateDevice(
		cdp->Adapter,
		cdp->DeviceType,
		Ghwnd,
		cdp->BahaviorFlags,
		&cdp->PParameters,
		&GlpD3DDevice);
}

VOID ResizeWindow(DWORD Width, DWORD Height) {
	if (!Gafull && GlpD3DDevice != NULL) {
		if (Height <= 0L) Height = 1L;
		if (Width <= 0L) Width = 1L;
		GWndCDP.PParameters.BackBufferWidth = Width;
		GWndCDP.PParameters.BackBufferHeight = Height;
		if (GlpD3DDevice->Reset(&GWndCDP.PParameters) == E_OUTOFMEMORY)
			MessageBox(Ghwnd, TEXT("Chyba"), APPNAME, MB_ICONERROR);
	}
}

VOID SwapD3DDevice() {
	Gafull = !Gafull;
	RestoreD3D();

	if (!Gafull) {
		RECT WindowRect;
//		GetWindowRect(Ghwnd, &WindowRect);
		WindowRect.left = 10L;
		WindowRect.top = 20L;
		WindowRect.right = GWndCDP.PParameters.BackBufferWidth;
		WindowRect.bottom = GWndCDP.PParameters.BackBufferHeight;
//		AdjustWindowRectEx(&WindowRect, WS_OVERLAPPEDWINDOW | WS_VISIBLE, FALSE, 0);
		MoveWindow(Ghwnd, WindowRect.left, WindowRect.top, WindowRect.right, WindowRect.bottom, TRUE);
	}
}

#include <stdio.h>
HRESULT InitD3D() {
	if (NULL == (GlpD3D = Direct3DCreate8(D3D_SDK_VERSION)) )
		return E_FAIL;
/*
	HDC hdc=GetDC(hwnd);
	char str[150];

	sprintf(str, "%d x %d, Adapter: %d, Mod: %d,", GSInfo.Display.Width, GSInfo.Display.Height,  GSInfo.Adapter, GSInfo.Mode);
	TextOut(hdc, 10, 10, str, strlen(str));
	if (GSInfo.FullScreen) TextOut(hdc, 10, 35, "FullScreen", strlen("FullScreen"));

	ReleaseDC(hwnd, hdc);

	MessageBox(NULL, TEXT("Zruit konzoli"), APPNAME, MB_ICONINFORMATION);
*/
/*
	CheckDeviceFormat(
		D3DADAPTER_DEFAULT,
		D3DDEVTYPE_HAL,
		d3ddm.Format,
		D3DUSAGE_RENDERTARGET,
		D3DRTYPE_SURFACE,
*/

	if (Gafull)
		if (FAILED(CreateD3DDevice(&GFullCDP))) return E_FAIL;
	if (!Gafull)
		if (FAILED(CreateD3DDevice(&GWndCDP))) return E_FAIL;


	return S_OK;
}

VOID CleanD3D() {
	CleanFinalOther();
	if (GlpD3DDevice != NULL) 
		GlpD3DDevice->Release();
	if (GlpD3D != NULL) {
		GlpD3D->Release();
	}
}

VOID RestoreD3D() {
	CleanOther();
//	MessageBox(NULL, TEXT("Ztrta Direct3D objektu."), APPNAME, MB_ICONERROR);

	if (Gafull) GlpD3DDevice->Reset(&GFullCDP.PParameters);
	if (!Gafull) GlpD3DDevice->Reset(&GWndCDP.PParameters);

	if (Gafull) GBBufferAspectRatio = GMonitorAspectRatio;
	if (!Gafull) GBBufferAspectRatio = (FLOAT)GWndCDP.PParameters.BackBufferWidth/(FLOAT)GWndCDP.PParameters.BackBufferHeight;

/*
	HRESULT hr = D3D_OK;
	hr = GlpD3DDevice->Reset(&GD3Dpp);
	if (hr == D3DERR_INVALIDCALL) MessageBox(NULL, TEXT("patn voln."), APPNAME, MB_ICONERROR);
	if (hr == D3DERR_OUTOFVIDEOMEMORY) MessageBox(NULL, TEXT("Chyba pi prci s video pamt."), APPNAME, MB_ICONERROR);
	if (hr == E_OUTOFMEMORY) MessageBox(NULL, TEXT("Chyba pi prci s pamt."), APPNAME, MB_ICONERROR);
	if (hr != D3D_OK) {
		MessageBox(NULL, TEXT("Zazen se nepodaio resetovat."), APPNAME, MB_ICONERROR);
		DestroyWindow(Ghwnd);
	}
*/
	RestoreOther();
}


HRESULT LoadMesh(char *file, LPD3DXMESH *g_pMesh, D3DMATERIAL8** g_pMeshMaterials, LPDIRECT3DTEXTURE8** g_pMeshTextures, DWORD *g_dwNumMaterials) {
	LPD3DXBUFFER pD3DXMtrlBuffer;

	if (FAILED(D3DXLoadMeshFromX(
		file,
		D3DXMESH_SYSTEMMEM,
		GlpD3DDevice, NULL,
		&pD3DXMtrlBuffer,
		g_dwNumMaterials,
		g_pMesh)))
		return E_FAIL;

	D3DXMATERIAL *d3dxMaterials = (D3DXMATERIAL *)pD3DXMtrlBuffer->GetBufferPointer();
	(*g_pMeshMaterials) = new D3DMATERIAL8[*g_dwNumMaterials];
	(*g_pMeshTextures) = new LPDIRECT3DTEXTURE8[*g_dwNumMaterials];

	for (DWORD i = 0; i < (*g_dwNumMaterials); i ++) {
		(*g_pMeshMaterials[i]) = d3dxMaterials[i].MatD3D;
		g_pMeshMaterials[i]->Ambient = g_pMeshMaterials[i]->Diffuse;
		if (FAILED(D3DXCreateTextureFromFile(GlpD3DDevice,
                                               d3dxMaterials[i].pTextureFilename, 
                                               g_pMeshTextures[i]))) {
			(*g_pMeshTextures[i]) = NULL;
		}
	}

	pD3DXMtrlBuffer->Release();

	return S_OK;
}

//LPD3DXPMESH meshEarth;
LPD3DXMESH meshEarth;
LPDIRECT3DTEXTURE8 textureEarth;
//LPD3DXMESH meshAtmos;
//D3DMATERIAL8 materialAtmos;
D3DMATERIAL8 materialStd;
//LPDIRECT3DTEXTURE8 textureCloud;

LPD3DXMESH meshOkoli;
LPDIRECT3DTEXTURE8 textureOkoli;
/*
struct CTVERTEX
{
	D3DXVECTOR3 pos;
	D3DCOLOR    color;
	FLOAT		tu, tv;
};

enum {D3DFVF_CTVERTEX = D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1};
*/
LPDIRECT3DTEXTURE8 textureCtverec;
LPDIRECT3DTEXTURE8 texturePruhl;
LPDIRECT3DVERTEXBUFFER8 D3DVB;
LPDIRECT3DVERTEXBUFFER8 VBhorizont;

void CleanOther() {
	if (meshEarth != NULL)
		meshEarth->Release();
/*
	if (meshAtmos != NULL)
		meshAtmos->Release();
*/
	if (meshOkoli != NULL)
		meshOkoli->Release();

	if (D3DVB != NULL)
		D3DVB->Release();

	if (VBhorizont != NULL)
		VBhorizont->Release();
}

void CleanFinalOther() {
	if (textureEarth != NULL)
		textureEarth->Release();
/*
	if (textureCloud != NULL)
		textureCloud->Release();
*/
	if (textureCtverec != NULL)
		textureCtverec->Release();

	if (textureOkoli != NULL)
		textureOkoli->Release();

	CleanOther();
}

HRESULT D3DXCreateSphereTexDif(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  LPD3DXMESH* ppMesh,
  LPD3DXBUFFER* ppAdjacency
  ) {
	HRESULT hr = D3DXCreateSphere(pDevice, Radius, Slices, Stacks, ppMesh, ppAdjacency);
	if (hr != D3D_OK) return hr;

	(*ppMesh)->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1, pDevice, ppMesh);

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		DWORD c;
		FLOAT tu, tv;
	};

	TextMesh *ptm;
	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);
	UINT i = 0;
	for (i = 0; i < ((Stacks-1)*Slices+2); i ++) {
		ptm[i].tu = atan2f(ptm[i].y,ptm[i].x)/(2.0f*D3DX_PI);
		ptm[i].tv = (Radius - ptm[i].z)/(2.0f*Radius);
	}
	(*ppMesh)->UnlockVertexBuffer();

	return D3D_OK;
}

HRESULT D3DXCreateSphereTex(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  LPD3DXMESH* ppMesh,
  LPD3DXBUFFER* ppAdjacency
  ) {
	HRESULT hr = D3DXCreateSphere(pDevice, Radius, Slices, Stacks, ppMesh, ppAdjacency);
	if (hr != D3D_OK) return hr;

	(*ppMesh)->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1, pDevice, ppMesh);

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		FLOAT tu, tv;
	};

	TextMesh *ptm;
	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);
	UINT i = 0;
	for (i = 0; i < ((Stacks-1)*Slices+2); i ++) {
		ptm[i].tu = atan2f(ptm[i].y,ptm[i].x)/(2.0f*D3DX_PI);
		ptm[i].tv = (Radius - ptm[i].z)/(2.0f*Radius);
	}
	(*ppMesh)->UnlockVertexBuffer();

	return D3D_OK;
}

HRESULT D3DXCreateSphereTex(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  DWORD MinValue,
  DWORD Options,
  LPD3DXPMESH* ppPMesh
  ) {
	LPD3DXBUFFER pAdjacency;
	LPD3DXMESH pMesh;
	HRESULT hr = D3DXCreateSphereTex(pDevice, Radius, Slices, Stacks, &pMesh, &pAdjacency);
	if (hr != D3D_OK) return hr;

	DWORD *pDAdjacency = (DWORD *)pAdjacency->GetBufferPointer();
	hr = D3DXGeneratePMesh(pMesh, pDAdjacency, NULL, NULL, MinValue, Options, ppPMesh);
	if (hr != D3D_OK) return hr;

	return D3D_OK;
}

#define BOXX(x) x/4.0f
#define BOXY(y) y/3.0f

HRESULT D3DXCreateEnviromentBox(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Width,
  FLOAT Height,
  FLOAT Depth,
  LPD3DXMESH* ppMesh,
  LPD3DXBUFFER* ppAdjacency
  ) {
	
	HRESULT hr = D3DXCreateBox(
		pDevice,
		Width, Height, Depth,
		ppMesh,
		ppAdjacency);
	if (hr != D3D_OK) return hr;

	(*ppMesh)->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1, pDevice, ppMesh);

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		FLOAT tu, tv;
	};

	TextMesh *ptm;

	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);

//	FLOAT lhrx, lhry;

	UINT i;

	i = 0;
	ptm[i+0].tu = 1.0f/4.0f;
	ptm[i+0].tv = 2.0f/3.0f;
	ptm[i+1].tu = 1.0f/4.0f;
	ptm[i+1].tv = 1.0f/3.0f;
	ptm[i+2].tu = 2.0f/4.0f;
	ptm[i+2].tv = 1.0f/3.0f;
	ptm[i+3].tu = 2.0f/4.0f;
	ptm[i+3].tv = 2.0f/3.0f;
	i = 4;
	ptm[i+0].tu = 0.0f/4.0f;
	ptm[i+0].tv = 2.0f/3.0f;
	ptm[i+1].tu = 0.0f/4.0f;
	ptm[i+1].tv = 1.0f/3.0f;
	ptm[i+2].tu = 1.0f/4.0f;
	ptm[i+2].tv = 1.0f/3.0f;
	ptm[i+3].tu = 1.0f/4.0f;
	ptm[i+3].tv = 2.0f/3.0f;
	i = 8;
	ptm[i+0].tu = 3.0f/4.0f;
	ptm[i+0].tv = 2.0f/3.0f;
	ptm[i+1].tu = 3.0f/4.0f;
	ptm[i+1].tv = 1.0f/3.0f;
	ptm[i+2].tu = 4.0f/4.0f;
	ptm[i+2].tv = 1.0f/3.0f;
	ptm[i+3].tu = 4.0f/4.0f;
	ptm[i+3].tv = 2.0f/3.0f;
	i = 12;
	ptm[i+0].tu = 3.0f/4.0f;
	ptm[i+0].tv = 1.0f/3.0f;
	ptm[i+1].tu = 3.0f/4.0f;
	ptm[i+1].tv = 2.0f/3.0f;
	ptm[i+2].tu = 2.0f/4.0f;
	ptm[i+2].tv = 2.0f/3.0f;
	ptm[i+3].tu = 2.0f/4.0f;
	ptm[i+3].tv = 1.0f/3.0f;
	i = 16;
	ptm[i+0].tu = 1.0f/4.0f;
	ptm[i+0].tv = 3.0f/3.0f;
	ptm[i+1].tu = 1.0f/4.0f;
	ptm[i+1].tv = 2.0f/3.0f;
	ptm[i+2].tu = 2.0f/4.0f;
	ptm[i+2].tv = 2.0f/3.0f;
	ptm[i+3].tu = 2.0f/4.0f;
	ptm[i+3].tv = 3.0f/3.0f;
	i = 20;
	ptm[i+0].tu = 1.0f/4.0f;
	ptm[i+0].tv = 0.0f/3.0f;
	ptm[i+1].tu = 2.0f/4.0f;
	ptm[i+1].tv = 0.0f/3.0f;
	ptm[i+2].tu = 2.0f/4.0f;
	ptm[i+2].tv = 1.0f/3.0f;
	ptm[i+3].tu = 1.0f/4.0f;
	ptm[i+3].tv = 1.0f/3.0f;

/*
	i = 0;
	ptm[i+0].tu = BOXX(1.0f);
	ptm[i+0].tv = BOXY(2.0f);
	ptm[i+1].tu = BOXX(1.0f);
	ptm[i+1].tv = BOXY(1.0f);
	ptm[i+2].tu = BOXX(2.0f);
	ptm[i+2].tv = BOXY(1.0f);
	ptm[i+3].tu = BOXX(2.0f);
	ptm[i+3].tv = BOXY(2.0f);
	i = 4;
	ptm[i+0].tu = BOXX(0.0f);
	ptm[i+0].tv = BOXY(2.0f);
	ptm[i+1].tu = BOXX(0.0f);
	ptm[i+1].tv = BOXY(1.0f);
	ptm[i+2].tu = BOXX(1.0f);
	ptm[i+2].tv = BOXY(1.0f);
	ptm[i+3].tu = BOXX(1.0f);
	ptm[i+3].tv = BOXY(2.0f);
	i = 8;
	ptm[i+0].tu = BOXX(3.0f);
	ptm[i+0].tv = BOXY(2.0f);
	ptm[i+1].tu = BOXX(3.0f);
	ptm[i+1].tv = BOXY(1.0f);
	ptm[i+2].tu = BOXX(4.0f);
	ptm[i+2].tv = BOXY(1.0f);
	ptm[i+3].tu = BOXX(4.0f);
	ptm[i+3].tv = BOXY(2.0f);
	i = 12;
	ptm[i+0].tu = BOXX(3.0f);
	ptm[i+0].tv = BOXY(1.0f);
	ptm[i+1].tu = BOXX(3.0f);
	ptm[i+1].tv = BOXY(2.0f);
	ptm[i+2].tu = BOXX(2.0f);
	ptm[i+2].tv = BOXY(2.0f);
	ptm[i+3].tu = BOXX(2.0f);
	ptm[i+3].tv = BOXY(1.0f);
	i = 16;
	ptm[i+0].tu = BOXX(1.0f);
	ptm[i+0].tv = BOXY(3.0f);
	ptm[i+1].tu = BOXX(1.0f);
	ptm[i+1].tv = BOXY(2.0f);
	ptm[i+2].tu = BOXX(2.0f);
	ptm[i+2].tv = BOXY(2.0f);
	ptm[i+3].tu = BOXX(2.0f);
	ptm[i+3].tv = BOXY(3.0f);
	i = 20;
	ptm[i+0].tu = BOXX(1.0f);
	ptm[i+0].tv = BOXY(0.0f);
	ptm[i+1].tu = BOXX(2.0f);
	ptm[i+1].tv = BOXY(0.0f);
	ptm[i+2].tu = BOXX(2.0f);
	ptm[i+2].tv = BOXY(1.0f);
	ptm[i+3].tu = BOXX(1.0f);
	ptm[i+3].tv = BOXY(1.0f);
*/
/*
	FLOAT lhrx, lhry;
	for (i = 0; i < 24; i += 4) {
		if (i == 0) { lhrx = 1.0f/4.0f; lhry = 0.0f/3.0f; }
		if (i == 4) { lhrx = 0.0f/4.0f; lhry = 1.0f/3.0f; }
		if (i == 8) { lhrx = 1.0f/4.0f; lhry = 1.0f/3.0f; }
		if (i == 12) { lhrx = 2.0f/4.0f; lhry = 1.0f/3.0f; }
		if (i == 16) { lhrx = 3.0f/4.0f; lhry = 1.0f/3.0f; }
		if (i == 20) { lhrx = 1.0f/4.0f; lhry = 2.0f/3.0f; }
		ptm[i+0].tu = lhrx + 0.0f/4.0f;
		ptm[i+0].tv = lhry + 0.0f/3.0f;
		ptm[i+1].tu = lhrx + 1.0f/4.0f;
		ptm[i+1].tv = lhry + 0.0f/3.0f;
		ptm[i+2].tu = lhrx + 1.0f/4.0f;
		ptm[i+2].tv = lhry + 1.0f/3.0f;
		ptm[i+3].tu = lhrx + 0.0f/4.0f;
		ptm[i+3].tv = lhry + 1.0f/3.0f;
	}
*/
	for (i = 0; i < 24; i ++) {
		ptm[i].nx *= -1.0f;
		ptm[i].ny *= -1.0f;
		ptm[i].nz *= -1.0f;

		ptm[i].x += ptm[i].nx*Width;
		ptm[i].y += ptm[i].ny*Height;
		ptm[i].z += ptm[i].nz*Depth;
	
	}
	(*ppMesh)->UnlockVertexBuffer();

	return D3D_OK;
}

HRESULT D3DXCreateEnviromentSphere(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  LPD3DXMESH* ppMesh,
  LPD3DXBUFFER* ppAdjacency
  ) {
	HRESULT hr = D3DXCreateSphere(pDevice, Radius, Slices, Stacks, ppMesh, ppAdjacency);
	if (hr != D3D_OK) return hr;

	(*ppMesh)->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1, pDevice, ppMesh);

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		FLOAT tu, tv;
	};

	TextMesh *ptm;
	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);
	UINT i = 0;
	for (i = 0; i < ((Stacks-1)*Slices+2); i ++) {
		ptm[i].tu = atan2f(ptm[i].y,ptm[i].x)/(2.0f*D3DX_PI);
		ptm[i].tv = (Radius - ptm[i].z)/(2.0f*Radius);
	}
	for (i = 0; i < ((Stacks-1)*Slices+2); i ++) {
		ptm[i].nx *= -1.0f;
		ptm[i].ny *= -1.0f;
		ptm[i].nz *= -1.0f;

		ptm[i].x = ptm[i].nx*Radius;
		ptm[i].y = ptm[i].ny*Radius;
		ptm[i].z = ptm[i].nz*Radius;
	}
	(*ppMesh)->UnlockVertexBuffer();

	return D3D_OK;
}

void RestoreOther() {
	FLOAT a = 2.05f;
	D3DCOLOR b = 0x000000ff;
/*
	GlpD3DDevice->CreateVertexBuffer(4*sizeof(CTVERTEX),
		0,
		D3DFVF_CTVERTEX,
		D3DPOOL_DEFAULT,
		&D3DVB);
*/
/*
	VOID* pVertices;
	D3DVB->Lock(0, sizeof(ctverec), (BYTE**)&pVertices, 0);
	memcpy(pVertices, ctverec, sizeof(ctverec));
	D3DVB->Unlock();
*/
/*
	CTVERTEX* pVertices;
	D3DVB->Lock(0, 0, (BYTE**)&pVertices, 0);
	pVertices[0].pos.x = -0.5f*a;
	pVertices[0].pos.y = -0.5f*a;
	pVertices[0].pos.z =  0.0f;
	pVertices[0].color = b;
	pVertices[0].tu = 0.0f;
	pVertices[0].tv = 1.0f;

	pVertices[1].pos.x = -0.5f*a;
	pVertices[1].pos.y =  0.5f*a;
	pVertices[1].pos.z =  0.0f;
	pVertices[1].color = b;
	pVertices[1].tu = 0.0f;
	pVertices[1].tv = 0.0f;

	pVertices[2].pos.x =  0.5f*a;
	pVertices[2].pos.y = -0.5f*a;
	pVertices[2].pos.z =  0.0f;
	pVertices[2].color = b;
	pVertices[2].tu = 1.0f;
	pVertices[2].tv = 1.0f;

	pVertices[3].pos.x =  0.5f*a;
	pVertices[3].pos.y =  0.5f*a;
	pVertices[3].pos.z =  0.0f;
	pVertices[3].color = b;
	pVertices[3].tu =  1.0f;
	pVertices[3].tv =  0.0f;
	D3DVB->Unlock();
*/
	struct AtmosVertex
	{
		D3DXVECTOR3 pos;
		D3DCOLOR    color;
	};

	DWORD NV = 64;
	GlpD3DDevice->CreateVertexBuffer(2*NV*sizeof(AtmosVertex),
		0,
		D3DFVF_XYZ | D3DFVF_DIFFUSE,
		D3DPOOL_DEFAULT,
		&VBhorizont);

	DWORD SL = 24, ST = 24;
	FLOAT SR = 1.0f;
	D3DXCreateSphereTexDif(
		GlpD3DDevice,
		SR,
		SL,
		ST,
		&meshEarth,
		NULL);

/*
	D3DXCreateSphereTex(
		GlpD3DDevice,
		SR,
		SL,
		ST,
		50,
		D3DXMESHSIMP_FACE,
		&meshEarth);
*/
/*	D3DXCreateSphere(
		GlpD3DDevice,
		SR*1.03f,
		32,
		32,
		&meshAtmos,
		NULL);

	meshAtmos->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE, GlpD3DDevice, &meshAtmos);
*/
	D3DCOLORVALUE blue =    {0.0f, 0.0f, 0.8f, 0.5f};
	D3DCOLORVALUE red =     {1.0f, 0.0f, 0.0f, 0.0f};
	D3DCOLORVALUE black =   {0.0f, 0.0f, 0.0f, 1.0f};
	D3DCOLORVALUE white =   {1.0f, 1.0f, 1.0f, 0.0f};
	D3DCOLORVALUE darkred = {0.5f, 0.0f, 0.0f, 0.0f};
/*
	ZeroMemory(&materialAtmos, sizeof(D3DMATERIAL8));
	materialAtmos.Diffuse = blue;
	materialAtmos.Ambient = black;
	materialAtmos.Specular = white;
	materialAtmos.Emissive = black;
	materialAtmos.Power = 50.0f;
*/
	ZeroMemory(&materialStd, sizeof(D3DMATERIAL8));
	materialStd.Diffuse = white;
	materialStd.Ambient = black;
	materialStd.Specular = white;
	materialStd.Emissive = black;
	materialStd.Power = 0.0f;

//	D3DXCreateEnviromentBox(GlpD3DDevice, 1.0f, 1.0f, 1.0f, &meshOkoli, NULL);
//	D3DXCreateEnviromentSphere(GlpD3DDevice, 1.0f, 16, 16, &meshOkoli, NULL);
//	D3DXCreateSphereTex(GlpD3DDevice, 3.0f, 16, 16, &meshOkoli, NULL);

	D3DXVECTOR3 vecDir;
	D3DLIGHT8 light;
	ZeroMemory(&light, sizeof(D3DLIGHT8));
/*
	light.Type = D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 0.9f;
	light.Specular.r = 1.0f;
	light.Specular.g = 1.0f;
	light.Specular.b = 1.0f;
	light.Ambient.r = 0.0f;
	light.Ambient.g = 0.0f;
	light.Ambient.b = 0.0f;
	vecDir = D3DXVECTOR3(-6.0f, -4.0f, -3.0f);
//	vecDir = D3DXVECTOR3(0.0f, 0.0f, 5.0f);
	D3DXVec3Normalize((D3DXVECTOR3 *)&light.Direction, &vecDir);
	light.Range = 1000.0f;
*/

	light.Type = D3DLIGHT_POINT;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 0.9f;
	light.Specular.r = 1.0f;
	light.Specular.g = 1.0f;
	light.Specular.b = 1.0f;
	light.Ambient.r = 0.0f;
	light.Ambient.g = 0.0f;
	light.Ambient.b = 0.0f;
	light.Position = D3DXVECTOR3(-26.0f, -24.0f, -3.0f);
//	light.Position = D3DXVECTOR3(0.0f, 0.0f, -5.0f);

	light.Range = 1000.0f;
	light.Attenuation0 = 1.0f;
	light.Attenuation1 = 0.0f;
	light.Attenuation2 = 0.0f;


	GlpD3DDevice->SetLight(0, &light);
	GlpD3DDevice->LightEnable(0, TRUE);
	GlpD3DDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
	GlpD3DDevice->SetRenderState(D3DRS_AMBIENT, 0x00808080);
	

	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,
		&D3DXVECTOR3(0.0f, 3.0f, 3.0f),
		&D3DXVECTOR3(0.0f, 0.0f,  0.0f),
		&D3DXVECTOR3(1.0f, 0.0f,  0.0f));
	GlpD3DDevice->SetTransform(D3DTS_VIEW, &matView);

	
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj, D3DX_PI/4, GBBufferAspectRatio, 0.01f, 10000.0f);
	GlpD3DDevice->SetTransform(D3DTS_PROJECTION, &matProj);

}

VOID InitGeometry() {

	RestoreOther();
/*
	D3DXCreateTextureFromFile(
		GlpD3DDevice,
		TEXT("earthsurfacecloud1024.jpg"),
		&textureEarth);
*/

D3DXCreateTextureFromFileEx(
  GlpD3DDevice,
  TEXT("earthsurfacecloud8192.jpg"),
  8192,
  4096,
  4,
  0,
  D3DFMT_DXT1,
  D3DPOOL_MANAGED,
  D3DX_DEFAULT,
  D3DX_DEFAULT,
  0,
  NULL,
  NULL,
  &textureEarth
);

/*
D3DXCreateTextureFromFileEx(
  GlpD3DDevice,
  TEXT("earthsurfacecloud1024.jpg"),
  1024,
  512,
  1,
  0,
  D3DFMT_DXT1,
  D3DPOOL_MANAGED,
  D3DX_DEFAULT,
  D3DX_DEFAULT,
  0,
  NULL,
  NULL,
  &textureEarth
);
*/
/*
	D3DXCreateTextureFromFile(
		GlpD3DDevice,
		TEXT("earthcloud.jpg"),
		&textureCloud);
*/
/*
	D3DXCreateTextureFromFile(
		GlpD3DDevice,
		TEXT("atmosfera.jpg"),
		&textureCtverec);
*/
/*
	D3DXCreateTextureFromFile(
		GlpD3DDevice,
		TEXT("Texture1.dds"),
		&textureCtverec);
*/
/*
	D3DXCreateTextureFromFile(
		GlpD3DDevice,
		TEXT("Stars.jpg"),
		&textureOkoli);
*/
/*
	D3DXCreateTextureFromFile(
		GlpD3DDevice,
		TEXT("tycho8.jpg"),
		&textureOkoli);
*/
/*
D3DXCreateTextureFromFileEx(
  GlpD3DDevice,
  TEXT("tycho8.jpg"),
  2880,
  1440,
  1,
  0,
  D3DFMT_DXT1,
  D3DPOOL_MANAGED,
  D3DX_DEFAULT,
  D3DX_DEFAULT,
  0,
  NULL,
  NULL,
  &textureOkoli
);
*/

/*
	GlpD3DDevice->CreateTexture(
		500,
		500,
		2,
		0,
		D3DFMT_A8R8G8B8,
		D3DPOOL_MANAGED,
		&texturePruhl);

*/


}

VOID DeformMesh(LPD3DXMESH* ppMesh, FLOAT t) {

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		FLOAT tu, tv;
	};

	TextMesh *ptm;

	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);
	DWORD nv = (*ppMesh)->GetNumVertices();
	for (DWORD i = 0; i < nv; i ++) {
		FLOAT u = atan2f(ptm[i].y, ptm[i].x);
		FLOAT v = atan2f(ptm[i].z, sqrtf(ptm[i].x*ptm[i].x + ptm[i].y*ptm[i].y));
		FLOAT r = sinf(sqrtf(u*u + v*v)*4.0f + t)*sqrtf(u*u + v*v)*0.3f + 1.5f;
		ptm[i].x = ptm[i].nx*r;
		ptm[i].y = ptm[i].ny*r;
		ptm[i].z = ptm[i].nz*r;
	}
	(*ppMesh)->UnlockVertexBuffer();
}

//VOID EarthRender(LPD3DXMATRIX pCameraPosition, LPD3DXMATRIX *ppLightsPosition, DWORD nol) {
VOID EarthRender(LPD3DXMATRIX pCameraPosition) {
// polomer zeme 6378
// ionosfera 100 km
// ozonova vrstva 50 km
// mraky 10 km

	D3DLIGHT8 light;
	GlpD3DDevice->GetLight(0, &light);

	FLOAT Rz = 1.0f, Ra = 1.03f;		// Rz - polomer Zeme, Ra - Polomer atmosfery
	FLOAT Rz2 = Rz*Rz, Ra2 = Ra*Ra;
	FLOAT h = Rz - Ra;					// tloustka atmosfery

	D3DXVECTOR3 CPos, LPos, EPos;		// CPos - pozice kamery, LPos - pozice svetla, EPos - pozice Zeme
	
	CPos.x = pCameraPosition->_41;
	CPos.y = pCameraPosition->_42;
	CPos.z = pCameraPosition->_43;

	LPos.x = light.Position.x;
	LPos.y = light.Position.y;
	LPos.z = light.Position.z;

	EPos.x = 0.0f;
	EPos.y = 0.0f;
	EPos.z = 0.0f;

	FLOAT Vm = D3DX_PI*0.5f;			// Minimalni uhel viditelnosti
	FLOAT Om = asinf(Rz/Ra);			// Minimalni uhel osvetleni
	FLOAT Vcm = D3DX_PI-Om;				// Minimalni uhel viditelne atmosfery pod horizontem Zeme

	FLOAT lpv = 0.001f;					// Prumerna linearni pruhlednost vzduchu

	FLOAT a, b;							// uhel alpha - uhel mezi kamerou, bodem atmosfery a stredem Zeme
										// uhel beta - uhel mezi zdrojem svetla, bodem atmosfery a stredem Zeme
	FLOAT g;							// uhel gamma - uhel mezi kamerou, bodem atmosfery a zdrojem svetla

	FLOAT ca, cb;						// cosiny uhlu alpha a beta
	FLOAT cg;							// cosinus uhlu gamma


	FLOAT x1, y1, z1;					// vektor smerujici od bodu atmosfery ke stredu Zeme
	FLOAT x2, y2, z2;					// vektor smerujici od bodu atmosfery ke kamere
	FLOAT x3, y3, z3;					// vektor smerujici od bodu atmosfery ke zdroji svetla

	
	D3DXVECTOR3 pp, qq, rr;				// pp - vektor smerujici od stredu Zeme ke kamere
										// qq - vektor kolmy na pp
										// rr - vektor kolmy na pp a qq
	D3DXVECTOR3 ii, jj, kk;				// jednotkove vektory vektoru pp, qq, rr
	D3DXVECTOR3 ll;						// jednotkovy vektor smerujici od stredu zeme k bodu atmosfery

	D3DXVECTOR3 A;						// stred kruznice

	FLOAT s, r;							// s - vzdalenost stredu kruznice od pocatku
										// r - polomer kruznice

	pp = CPos - EPos;

	qq.x = 1.0f;
	qq.y = 1.0f;
	qq.z = 1.0f;

	if (pp.x != 0) {
		qq.x = -(qq.y*pp.y + qq.z*pp.z)/pp.x;
	} else {
		if (pp.y != 0) {
			qq.y = -(qq.x*pp.x + qq.z*pp.z)/pp.y;
		} else {
			if (pp.z != 0) {
				qq.z = -(qq.x*pp.x + qq.y*pp.y)/pp.z;
			} else {
				//chyba
			}
		}
	}

	D3DXVec3Cross(&rr, &pp, &qq);
	D3DXVec3Normalize(&ii, &pp);
	D3DXVec3Normalize(&jj, &qq);
	D3DXVec3Normalize(&kk, &rr);

	s = Rz2/(D3DXVec3Length(&pp));
	r = sqrtf(Rz2-s*s)*0.988f;

	A = ii*s;


	struct AtmosVertex
	{
		D3DXVECTOR3 pos;
		D3DCOLOR    color;
	};

	AtmosVertex* pVertices;

	VBhorizont->Lock(0, 0, (BYTE**)&pVertices, 0);

	DWORD NV = 64;
	FLOAT t = 0, krok = 2.0f*D3DX_PI/(FLOAT)(NV-1);
	for (DWORD j = 0; j < 2*NV; j += 2) {
		pVertices[j+1].pos = A + sinf(t)*r*jj + cosf(t)*r*kk;

		x1 = EPos.x - pVertices[j+1].pos.x;
		y1 = EPos.y - pVertices[j+1].pos.y;
		z1 = EPos.z - pVertices[j+1].pos.z;

		FLOAT v = 1.0f/sqrtf(x1*x1 + y1*y1 + z1*z1);
		ll.x = x1*v;
		ll.y = y1*v;
		ll.z = z1*v;
		pVertices[j].pos = pVertices[j+1].pos + ll*h;

		x2 = CPos.x - pVertices[j+1].pos.x;
		y2 = CPos.y - pVertices[j+1].pos.y;
		z2 = CPos.z - pVertices[j+1].pos.z;
		x3 = LPos.x - pVertices[j+1].pos.x;
		y3 = LPos.y - pVertices[j+1].pos.y;
		z3 = LPos.z - pVertices[j+1].pos.z;
		cg = (x2*x3 + y2*y3 + z2*z3)/sqrtf((x2*x2 + y2*y2 + z2*z2)*(x3*x3 + y3*y3 + z3*z3));
		g = acosf(cg);

		x3 = LPos.x - pVertices[j+1].pos.x;
		y3 = LPos.y - pVertices[j+1].pos.y;
		z3 = LPos.z - pVertices[j+1].pos.z;
		cb = (x1*x3 + y1*y3 + z1*z3)/sqrtf((x1*x1 + y1*y1 + z1*z1)*(x3*x3 + y3*y3 + z3*z3));
		b = acosf(cb);

		FLOAT sv;
//		if (b >= Om) sv = -1.0f/(Om-D3DX_PI)*b + Om/(Om - D3DX_PI);
		if (b >= Om) sv = -1.0f/(Om-D3DX_PI-0.1f)*b + (Om-0.1f)/(Om-D3DX_PI-0.1f);
		else sv = 0.0f;

		FLOAT b = g/D3DX_PI;
		pVertices[j+1].color = D3DCOLOR_COLORVALUE(b*sv, b*sv, (1.0f-b)*sv, sv);
//		pVertices[j].color = D3DCOLOR_COLORVALUE(b, b, 1.0f-b, 1.0f);
//		pVertices[j+1].color = 0xff0000ff;
		pVertices[j].color = 0x00000000;
		t += krok;
	}

	VBhorizont->Unlock();



	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		DWORD c;
		FLOAT tu, tv;
	};

	TextMesh *ptm;

	meshEarth->LockVertexBuffer(0, (BYTE **)&ptm);

	DWORD nv = meshEarth->GetNumVertices();
	for (DWORD i = 0; i < nv; i ++) {
		x1 = EPos.x - ptm[i].x;
		y1 = EPos.y - ptm[i].y;
		z1 = EPos.z - ptm[i].z;
		x2 = CPos.x - ptm[i].x;
		y2 = CPos.y - ptm[i].y;
		z2 = CPos.z - ptm[i].z;
		ca = (x1*x2 + y1*y2 + z1*z2)/sqrtf((x1*x1 + y1*y1 + z1*z1)*(x2*x2 + y2*y2 + z2*z2));
		a = acosf(ca);
		if (a >= Vm-0.1f) {
			x3 = LPos.x - ptm[i].x;
			y3 = LPos.y - ptm[i].y;
			z3 = LPos.z - ptm[i].z;
			cb = (x1*x3 + y1*y3 + z1*z3)/sqrtf((x1*x1 + y1*y1 + z1*z1)*(x3*x3 + y3*y3 + z3*z3));
			b = acosf(cb);
			if (b >= Om) {
					FLOAT c2 = ca*ca;
					FLOAT t = sqrtf(Ra2 - Rz2 + 2*Rz2*c2 - 2*sqrtf(Rz2*c2*(Ra2 - Rz2 + Rz2*c2)));
						// t - delka drahy paprsku atmosferou
					FLOAT p = powf(lpv, t);
						// p - pruhlednost
					cg = (x2*x3 + y2*y3 + z2*z3)/sqrtf((x2*x2 + y2*y2 + z2*z2)*(x3*x3 + y3*y3 + z3*z3));
					g = acosf(cg);
					FLOAT b = g/D3DX_PI;
					FLOAT cr = b, cg = b, cb = (1.0f-b);
					ptm[i].c = D3DCOLOR_COLORVALUE((1.0-cr)*p+cr, (1.0-cg)*p+cg, (1.0-cb)*p+cb, 1.0f-p);
//					ptm[i].c = D3DCOLOR_COLORVALUE(1.0f-p, 1.0f-p, 1.0f, p);
//					ptm[i].c = D3DCOLOR_RGBA(255, 255, 255, 0);
//					ptm[i].c = D3DCOLOR_COLORVALUE(0.0f, 0.0f, 1.0f-0.5f*p, 1.0f-p);
			} else {
//				ptm[i].c = D3DCOLOR_RGBA(0, 0, 200, 255);
				ptm[i].c = D3DCOLOR_RGBA(0, 0, 0, 255);
			}
		}
	}

	meshEarth->UnlockVertexBuffer();



	D3DXMATRIX matHelp;
	
	D3DXMatrixIdentity(&matHelp);
	GlpD3DDevice->SetTransform(D3DTS_WORLD, &matHelp);

	GlpD3DDevice->SetRenderState(D3DRS_DITHERENABLE, TRUE);
	GlpD3DDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
	GlpD3DDevice->SetRenderState(D3DRS_ZENABLE, TRUE);
	GlpD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);

	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTEXF_LINEAR);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_LINEAR);


	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE);

//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);
/*
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_BLENDDIFFUSEALPHA);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);
*/	
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MIPMAPLODBIAS, FtoDW(-1.5f));
	GlpD3DDevice->SetRenderState(D3DRS_WRAP0, D3DWRAPCOORD_0);

	GlpD3DDevice->SetMaterial(&materialStd);
	GlpD3DDevice->SetTexture(0, textureEarth);
	meshEarth->DrawSubset(0);

	GlpD3DDevice->SetRenderState(D3DRS_DITHERENABLE, TRUE);
	GlpD3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
	GlpD3DDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
	GlpD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);

	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_DIFFUSE);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);

	GlpD3DDevice->SetStreamSource(0, VBhorizont, sizeof(AtmosVertex));
	GlpD3DDevice->SetVertexShader(D3DFVF_XYZ | D3DFVF_DIFFUSE);
	GlpD3DDevice->SetTexture(0, NULL);
	GlpD3DDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2*NV-2);

}


FLOAT otoc = -1.5f, posun = 4.0f;
BOOL zm = TRUE;

D3DXMATRIX matCamRot;
D3DXMATRIX matCamTrn;

	D3DXMATRIX matView;
	D3DXMATRIX matBilboard;
	D3DXMATRIX matHelp, matHelp0;

VOID Render() {
//	GlpD3DDevice->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(255, 255, 255), 1.0f, 0);
	GlpD3DDevice->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0, 0, 0), 1.0f, 0);
	GlpD3DDevice->BeginScene();

	otoc += 0.005f;
	if (zm) posun -= 0.001f;
	if (!zm) posun += 0.001f;
	if (posun < 2.02f) zm = FALSE;
	if (posun > 5.0f) zm = TRUE;

//	SetRenderState(D3DRS_WRAPx, ...) 		

/*
	FLOAT x = 0.0f, y = 0.0f, z = -3.0f;
	FLOAT alpha = 0.5f;
*/


//	D3DXMatrixIdentity(&matCamTrn);
	D3DXMatrixTranslation(&matCamTrn, -sinf(otoc)*posun, 0.0f, -cosf(otoc)*posun);
//	D3DXMatrixRotationYawPitchRoll(&matCamRot, posun, otoc, 0.0f);
	D3DXMatrixRotationX(&matHelp, -0.4f);
	D3DXMatrixRotationY(&matCamRot, otoc);
//	D3DXMatrixMultiply(&matCamRot, &matCamRot, &matHelp);
//	D3DXMatrixRotationX(&matCamRot, 0.0f);
//	D3DXMatrixRotationX(&matCamRot, D3DX_PI);

/*	D3DXMatrixRotationX(&matHelp, D3DX_PI*0.5f);
	D3DXMatrixRotationZ(&matHelp0, D3DX_PI*1.5f);
	D3DXMatrixMultiply(&matCamRot, &matHelp, &matHelp0);
*/

	D3DXMatrixMultiply(&matHelp, &matCamRot, &matCamTrn);
	D3DXMatrixInverse(&matView, NULL, &matHelp);

	GlpD3DDevice->SetTransform(D3DTS_VIEW, &matView);

/*
	D3DXMatrixRotationY(&matCamRot, otoc);
	D3DXMatrixTranslation(&matCamTrn, 0.0f, 0.0f, -posun);
//	D3DXMatrixTranslation(&matCamTrn, sinf(otoc)*posun, 0.0f, cosf(otoc)*posun);
//	D3DXMatrixMultiply(&matHelp, &matCamRot, &matCamTrn);
	matHelp = -matCamRot;
	matHelp0 = -matCamTrn;
	D3DXMatrixMultiply(&matHelp, &matHelp, &matHelp0);
//	D3DXMatrixMultiply(&matHelp, &matCamTrn, &matCamRot);
//	D3DXMatrixInverse(&matView, NULL, &matHelp);
//	D3DXMatrixInverse(&matHelp, NULL, &matCamRot);
//	GlpD3DDevice->SetTransform(D3DTS_VIEW, &matView);
	GlpD3DDevice->SetTransform(D3DTS_VIEW, &matHelp);
*/

/*
//	D3DXMatrixTranslation(&matHelp, 0.0f, 0.0f, 3.0f);
	D3DXMatrixIdentity(&matHelp);
	GlpD3DDevice->SetTransform(D3DTS_WORLD, &matHelp);
	GlpD3DDevice->SetMaterial(&materialStd);
*/

/*
	GlpD3DDevice->SetTransform(D3DTS_WORLD, &matCamTrn);
	GlpD3DDevice->SetRenderState(D3DRS_WRAP0, D3DWRAPCOORD_0);
	GlpD3DDevice->SetTexture(0, textureOkoli);

	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTEXF_LINEAR);
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_LINEAR);

	GlpD3DDevice->SetTextureStageState(0, D3DTSS_MIPMAPLODBIAS, FtoDW(-2.0f));

	GlpD3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
	GlpD3DDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
	GlpD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	meshOkoli->DrawSubset(0);
*/

/*
	D3DXMatrixTranslation(&matView, 0.0f, 0.0f, posun);
	D3DXMatrixRotationY(&matHelp, otoc);
	D3DXMatrixMultiply(&matView, &matHelp, &matView);
	GlpD3DDevice->SetTransform(D3DTS_VIEW, &matView);
*/

/*
	D3DXMatrixTranslation(&matHelp, 0.0f, 0.0f, 3.0f);
	D3DXMatrixRotationY(&matHelp0, 0.5f);
	D3DXMatrixMultiply(&matHelp, &matHelp0, &matHelp);
*/

	EarthRender(&matCamTrn);

/*

	FLOAT xp, yp, zp;
	xp = matCamTrn._41;
	yp = matCamTrn._42;
	zp = matCamTrn._43;
//	xp = -sinf(otoc)*posun;
	yp = 0.0f;
	zp = -cosf(otoc)*posun;
	FLOAT k = sqrtf(xp*xp + yp*yp + zp*zp);
	FLOAT h = 1.0f/k*0.5f;

	FLOAT a = atan2f(xp, zp) + D3DX_PI;
	FLOAT b = -atan2f(yp, sqrtf(xp*xp+zp*zp));
	D3DXMatrixRotationY(&matHelp, a);
	D3DXMatrixRotationX(&matHelp0, b);
	D3DXMatrixMultiply(&matHelp0, &matHelp, &matHelp0);

	D3DXMatrixTranslation(&matHelp, 0.0f, 0.0f, -h);

	D3DXMatrixMultiply(&matHelp, &matHelp, &matHelp0);

//	D3DXMatrixMultiply(&matHelp, &matHelp, &matCamRot);
	GlpD3DDevice->SetTransform(D3DTS_WORLD, &matHelp);
	GlpD3DDevice->SetRenderState(D3DRS_WRAP0, 0);
	GlpD3DDevice->SetTexture(0, textureCtverec);


    GlpD3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
//    GlpD3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    GlpD3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    GlpD3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
    GlpD3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);


	GlpD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
//	GlpD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	GlpD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
	GlpD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_SRCALPHA);
//	GlpD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHASAT);
//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_BLENDTEXTUREALPHA);
//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_COMPLEMENT);
//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_BLENDTEXTUREALPHA);
//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
//  GlpD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SUBTRACT);
//	GlpD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_DISABLE);
	GlpD3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
	GlpD3DDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
	GlpD3DDevice->SetStreamSource(0, D3DVB, sizeof(CTVERTEX));
	GlpD3DDevice->SetVertexShader(D3DFVF_CTVERTEX);
//	GlpD3DDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
*/
	
	GlpD3DDevice->EndScene();
	GlpD3DDevice->Present(NULL, NULL, NULL, NULL);
}

BOOL CreateWin() {
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance = GhInstance;
	wc.lpfnWndProc = WndProc;
	wc.lpszClassName = CLASSNAME;
	wc.lpszMenuName = NULL;
	wc.style = CS_HREDRAW | CS_VREDRAW;

	if (!RegisterClassEx(&wc)) return FALSE;

	RECT WindowRect;
	WindowRect.left = 10L;
	WindowRect.top = 20L;
	WindowRect.right = GWndCDP.PParameters.BackBufferWidth;
	WindowRect.bottom = GWndCDP.PParameters.BackBufferHeight;
//	AdjustWindowRectEx(&WindowRect, WS_OVERLAPPEDWINDOW | WS_VISIBLE, FALSE, 0);

	Ghwnd = CreateWindowEx(0,
		CLASSNAME, APPNAME,
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		WindowRect.left, WindowRect.top, WindowRect.right, WindowRect.bottom,
		NULL, NULL, GhInstance, NULL);
	
	if (!Ghwnd) return FALSE;

	return TRUE;
}

BOOL GetD3DDeviceParameters() {
	SETUPINFO SetupInfo;
	if (!Setup(GhInstance, &SetupInfo)) return FALSE;

	Gafull = SetupInfo.FullScreen;

	ZeroMemory(&GWndCDP.PParameters, sizeof(GWndCDP.PParameters));
	ZeroMemory(&GFullCDP.PParameters, sizeof(GFullCDP.PParameters));


	GWndCDP.PParameters.Windowed = TRUE;
	GWndCDP.PParameters.BackBufferWidth = 400;
	GWndCDP.PParameters.BackBufferHeight = 400;
	GWndCDP.PParameters.BackBufferFormat = SetupInfo.ActualDisplay.Format;
	GWndCDP.PParameters.SwapEffect = D3DSWAPEFFECT_DISCARD;
	GWndCDP.PParameters.EnableAutoDepthStencil = TRUE;
	GWndCDP.PParameters.AutoDepthStencilFormat = D3DFMT_D16;
	GWndCDP.Adapter = D3DADAPTER_DEFAULT;
	GWndCDP.DeviceType = D3DDEVTYPE_HAL;
	GWndCDP.BahaviorFlags = D3DCREATE_SOFTWARE_VERTEXPROCESSING;

	
	GFullCDP.PParameters.Windowed = FALSE;
	GFullCDP.PParameters.BackBufferWidth = SetupInfo.Display.Width;
	GFullCDP.PParameters.BackBufferHeight = SetupInfo.Display.Height;
	GFullCDP.PParameters.BackBufferFormat = SetupInfo.Display.Format;
	GFullCDP.PParameters.SwapEffect = D3DSWAPEFFECT_DISCARD;
	GFullCDP.PParameters.EnableAutoDepthStencil = TRUE;
	GFullCDP.PParameters.AutoDepthStencilFormat = D3DFMT_D16;
	GFullCDP.Adapter = SetupInfo.Adapter;
	GFullCDP.DeviceType = D3DDEVTYPE_HAL;
	GFullCDP.BahaviorFlags = D3DCREATE_SOFTWARE_VERTEXPROCESSING;


//	GD3Dpp.BackBufferFormat = D3DFMT_A8R8G8B8 ;
//	GD3Dpp.AutoDepthStencilFormat = D3DFMT_D32;

//	GD3Dpp.MultiSampleType = D3DMULTISAMPLE_2_SAMPLES;

	GMonitorAspectRatio = 4.0f/3.0f;

	if (Gafull) GBBufferAspectRatio = GMonitorAspectRatio;
	if (!Gafull) GBBufferAspectRatio = (FLOAT)GWndCDP.PParameters.BackBufferWidth/(FLOAT)GWndCDP.PParameters.BackBufferHeight;

	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
	
	GhInstance = hInstance;

	if (!GetD3DDeviceParameters()) return 0;

	if (!CreateWin()) return 0;

	if (!SUCCEEDED(InitD3D())) {
		MessageBox(NULL, TEXT("Nepodailo se inicializovat Direct3D"), APPNAME, MB_ICONERROR);
		return 0;
	}

	InitGeometry();

	MSG msg;
	BOOL gm = TRUE;
	while (gm) {
		if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
			if(gm = GetMessage(&msg, NULL, 0, 0)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else {
			if (GlpD3DDevice->TestCooperativeLevel() == D3D_OK) {
				if (!GPause) Render();
			} else {
				if (GlpD3DDevice->TestCooperativeLevel() == D3DERR_DEVICENOTRESET) RestoreD3D();
//				RestoreD3D();
			}
		}
	}

	CleanD3D();

	return msg.wParam;
}