
inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }


HRESULT LoadMesh(LPDIRECT3DDEVICE8 pDevice, char *file, LPD3DXMESH *g_pMesh, D3DMATERIAL8** g_pMeshMaterials, LPDIRECT3DTEXTURE8** g_pMeshTextures, DWORD *g_dwNumMaterials) {
	LPD3DXBUFFER pD3DXMtrlBuffer;

	if (FAILED(D3DXLoadMeshFromX(
		file,
		D3DXMESH_SYSTEMMEM,
		pDevice, NULL,
		&pD3DXMtrlBuffer,
		g_dwNumMaterials,
		g_pMesh)))
		return E_FAIL;

	D3DXMATERIAL *d3dxMaterials = (D3DXMATERIAL *)pD3DXMtrlBuffer->GetBufferPointer();
	(*g_pMeshMaterials) = new D3DMATERIAL8[*g_dwNumMaterials];
	(*g_pMeshTextures) = new LPDIRECT3DTEXTURE8[*g_dwNumMaterials];

	for (DWORD i = 0; i < (*g_dwNumMaterials); i ++) {
		(*g_pMeshMaterials[i]) = d3dxMaterials[i].MatD3D;
		g_pMeshMaterials[i]->Ambient = g_pMeshMaterials[i]->Diffuse;
		if (FAILED(D3DXCreateTextureFromFile(pDevice,
                                               d3dxMaterials[i].pTextureFilename, 
                                               g_pMeshTextures[i]))) {
			(*g_pMeshTextures[i]) = NULL;
		}
	}

	pD3DXMtrlBuffer->Release();

	return S_OK;
}

void CleanOther() {
}

void CleanFinalOther() {
	CleanOther();
}

HRESULT D3DXCreateSphereTexDif(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  LPD3DXMESH* ppMesh,
  LPD3DXBUFFER* ppAdjacency
  ) {
	HRESULT hr = D3DXCreateSphere(pDevice, Radius, Slices, Stacks, ppMesh, ppAdjacency);
	if (hr != D3D_OK) return hr;

	(*ppMesh)->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1, pDevice, ppMesh);

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		DWORD c;
		FLOAT tu, tv;
	};

	TextMesh *ptm;
	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);
	UINT i = 0;
	for (i = 0; i < ((Stacks-1)*Slices+2); i ++) {
		ptm[i].tu = 2.0f*D3DX_PI - atan2f(ptm[i].y,ptm[i].x)/(2.0f*D3DX_PI);
		ptm[i].tv = (Radius - ptm[i].z)/(2.0f*Radius);
	}
	(*ppMesh)->UnlockVertexBuffer();

	return D3D_OK;
}

HRESULT D3DXCreateSphereTex(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  LPD3DXMESH* ppMesh,
  LPD3DXBUFFER* ppAdjacency
  ) {
	HRESULT hr = D3DXCreateSphere(pDevice, Radius, Slices, Stacks, ppMesh, ppAdjacency);
	if (hr != D3D_OK) return hr;

	(*ppMesh)->CloneMeshFVF(0, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1, pDevice, ppMesh);

	struct TextMesh {
		FLOAT x, y, z;
		FLOAT nx, ny, nz;
		FLOAT tu, tv;
	};

	TextMesh *ptm;
	(*ppMesh)->LockVertexBuffer(0, (BYTE **)&ptm);
	UINT i = 0;
	for (i = 0; i < ((Stacks-1)*Slices+2); i ++) {
		ptm[i].tu = atan2f(ptm[i].y,ptm[i].x)/(2.0f*D3DX_PI);
		ptm[i].tv = (Radius - ptm[i].z)/(2.0f*Radius);
	}
	(*ppMesh)->UnlockVertexBuffer();

	return D3D_OK;
}

HRESULT D3DXCreateSphereTex(
  LPDIRECT3DDEVICE8 pDevice,
  FLOAT Radius,
  UINT Slices,
  UINT Stacks,
  DWORD MinValue,
  DWORD Options,
  LPD3DXPMESH* ppPMesh
  ) {
	LPD3DXBUFFER pAdjacency;
	LPD3DXMESH pMesh;
	HRESULT hr = D3DXCreateSphereTex(pDevice, Radius, Slices, Stacks, &pMesh, &pAdjacency);
	if (hr != D3D_OK) return hr;

	DWORD *pDAdjacency = (DWORD *)pAdjacency->GetBufferPointer();
	hr = D3DXGeneratePMesh(pMesh, pDAdjacency, NULL, NULL, MinValue, Options, ppPMesh);
	if (hr != D3D_OK) return hr;

	return D3D_OK;
}