/*
class CTeleso {
public:
	FLOAT *x, *y, *z;		// Polohovy vektor
	FLOAT *a, *b, *g;		// Uhly natoceni
	FLOAT *vx, *vy, *vz;	// Vektor rychlosti
	FLOAT *va, *vb, *vg;	// Rychlost otaceni
	BOOL Bind;

	CTeleso(CTeleso *iTeleso) {
		Bind = TRUE;
		x = iTeleso->x;
		y = iTeleso->y;
		z = iTeleso->z;
		a = iTeleso->a;
		b = iTeleso->b;
		g = iTeleso->g;
		vx = iTeleso->vx;
		vy = iTeleso->vy;
		vz = iTeleso->vz;
		va = iTeleso->va;
		vb = iTeleso->vb;
		vg = iTeleso->vg;
	}

	CTeleso(FLOAT ix = 0.0f, FLOAT iy = 0.0f, FLOAT iz = 0.0f, FLOAT ia = 0.0f, FLOAT ib = 0.0f, FLOAT ig = 0.0f) {
		Bind = FALSE;
		x = y = z = a = b = g = NULL;
		vx = vy = vz = va = vb = vg = NULL;
		x = new FLOAT(ix);
		y = new FLOAT(iy);
		z = new FLOAT(iz);
		a = new FLOAT(ia);
		b = new FLOAT(ib);
		g = new FLOAT(ig);

		vx = new FLOAT(0.0f);
		vy = new FLOAT(0.0f);
		vz = new FLOAT(0.0f);
		va = new FLOAT(0.0f);
		vb = new FLOAT(0.0f);
		vg = new FLOAT(0.0f);
	}


	~CTeleso() {
		if (!Bind) delete x, y, z, a, b, g, vx, vy, vz, va, vb, vg;
	}

};
*/
/*
class CFyzika : CTeleso {
	VOID Newton(FLOAT cas_s) {
		x += vx * cas_s;
		y += vy * cas_s;
		z += vz * cas_s;

		a += va * cas_s;
		b += vb * cas_s;
		g += vg * cas_s;
	}
};
*/
/*
class CObjekt : CTeleso {

};
*/

class CTeleso {
public:
	FLOAT x, y, z;
	FLOAT a, b, g;
	FLOAT vx, vy, vz;
	FLOAT va, vb, vg;

	FLOAT m;
	FLOAT *tx, *ty, *tz;

	CTeleso() {
		tx = ty = tz = NULL;
		m = 1.0f;
		x = y = z = a = b = g = 0.0f;
		vx = vy = vz = va = vb = vg = 0.0f;
	}

	CTeleso(CTeleso *iTeleso, FLOAT im) {
		CTeleso();
		Bind(iTeleso);
		m = im;

	}

	CTeleso(FLOAT im) {
		CTeleso();
		m = im;
		tx = ty = tz = NULL;
	}

	VOID Bind(CTeleso *iTeleso) {
		tx = &(iTeleso->x);
		ty = &(iTeleso->y);
		tz = &(iTeleso->z);
	}
};

class CRender {
public:
	LPDIRECT3DDEVICE8 pDevice;

	virtual VOID Render();

	virtual VOID LoadManagedPool();
	virtual VOID LoadDefaultPool();
	virtual VOID CleanManagedPool();
	virtual VOID CleanDefaultPool();
};

class CPlaneta : CTeleso, CRender {
	char *Nazev;
	UINT ID;

	FLOAT Rp;
	BOOL BAtmosfera;

	LPDIRECT3DVERTEXBUFFER8	lpVBufferBod;

	struct BodVertex {
		FLOAT x, y, z;
		DWORD color;
	};
	enum {D3DFVF_BOD = D3DFVF_XYZ | D3DFVF_DIFFUSE};

	CPlaneta(LPDIRECT3DDEVICE8 ipDevice) {
		pDevice = ipDevice;
	}

	VOID Render() {
		pDevice->SetRenderState(D3DRS_DITHERENABLE, FALSE);
		pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
		pDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
		pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);

		pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
		pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_DIFFUSE);
		pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
		pDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);

		pDevice->SetStreamSource(0, lpVBufferBod, sizeof(BodVertex));
		pDevice->SetVertexShader(D3DFVF_BOD);
		pDevice->SetTexture(0, NULL);
		pDevice->DrawPrimitive(D3DPT_POINTLIST, 0, 1);
	}

	VOID LoadDefaultPool() {
		pDevice->CreateVertexBuffer(1*sizeof(BodVertex), 0, D3DFVF_BOD, D3DPOOL_DEFAULT, &lpVBufferBod);
		BodVertex* pVertices;
		lpVBufferBod->Lock(0, 0, (BYTE**)&pVertices, 0);
		pVertices[0].color = 0xffffffff;
		pVertices[0].x = 0.0f;
		pVertices[0].y = 0.0f;
		pVertices[0].z = 0.0f;
		lpVBufferBod->Unlock();
	}

	VOID CleanDefaultPool() {
		if (lpVBufferBod != NULL) lpVBufferBod->Release();
	}

	~CPlaneta() {
		CleanDefaultPool();
		CleanManagedPool();
	}
};

/*
class CGravit {
public:
	FLOAT m;
	FLOAT *tx, *ty, *tz;
//	BOOL Teziste;

	CGravit(CTeleso *iTeleso, FLOAT im) {
		tx = iTeleso->x;
		ty = iTeleso->y;
		tz = iTeleso->z;
		m = im;
	}
};
*/

class Objekt {
public:
	D3DXVECTOR3 Pozice;
	D3DXVECTOR3 Rychlost;
	FLOAT a, b, g;
	FLOAT va, vb, vg;
};

class Zeme : Objekt {
	LPDIRECT3DDEVICE8		pDevice;

	D3DMATERIAL8			MaterialStd;
	LPDIRECT3DTEXTURE8		lpTexturaPovrch;
	LPD3DXMESH				lpMeshPovrch;
	LPDIRECT3DVERTEXBUFFER8	lpVBufferHorizont;
	
	DWORD	MipMapBias;

	struct HorizontVertex
	{
		D3DXVECTOR3 pos;
		D3DCOLOR    color;
	};
	enum {D3DFVF_HORIZONT = D3DFVF_XYZ | D3DFVF_DIFFUSE};

	FLOAT Rz, Ra;
	DWORD SL, ST;
	DWORD NV;
	
public:
	Zeme(LPDIRECT3DDEVICE8 ipDevice, FLOAT iRz = 1.0f, FLOAT iRa = 1.03f) {
		pDevice = ipDevice;
		Rz = iRz;
		Ra = iRa;
		MipMapBias = FtoDW(-1.5f);
		SL = ST = 32;
		NV = 64;
		Pozice.x = 0.0f;
		Pozice.y = 0.0f;
		Pozice.z = 0.0f;
		LoadManaged();
		LoadDefault();
	}

	VOID LoadManaged() {

		D3DXCreateTextureFromFileEx(
		  pDevice,
		  TEXT("earthsurfacecloud8192.jpg"),
		  8192,
		  4096,
		  4,
		  0,
		  D3DFMT_DXT1,
		  D3DPOOL_MANAGED,
		  D3DX_DEFAULT,
		  D3DX_DEFAULT,
		  0,
		  NULL,
		  NULL,
		  &lpTexturaPovrch
		);
/*

		D3DXCreateTextureFromFileEx(
		  pDevice,
		  TEXT("earthsurfacecloud1024.jpg"),
		  1024,
		  512,
		  1,
		  0,
		  D3DFMT_DXT1,
		  D3DPOOL_MANAGED,
		  D3DX_DEFAULT,
		  D3DX_DEFAULT,
		  0,
		  NULL,
		  NULL,
		  &lpTexturaPovrch
		);
*/
	}

	VOID LoadDefault() {
		pDevice->CreateVertexBuffer(2*NV*sizeof(HorizontVertex),
			0,
			D3DFVF_HORIZONT,
			D3DPOOL_DEFAULT,
			&lpVBufferHorizont);

		D3DXCreateSphereTexDif(
			pDevice,
			Rz,
			SL,
			ST,
			&lpMeshPovrch,
			NULL);

		D3DCOLORVALUE blue =    {0.0f, 0.0f, 0.8f, 1.0f};
		D3DCOLORVALUE red =     {1.0f, 0.0f, 0.0f, 1.0f};
		D3DCOLORVALUE black =   {0.0f, 0.0f, 0.0f, 1.0f};
		D3DCOLORVALUE white =   {1.0f, 1.0f, 1.0f, 1.0f};
		D3DCOLORVALUE darkred = {0.5f, 0.0f, 0.0f, 1.0f};

		ZeroMemory(&MaterialStd, sizeof(D3DMATERIAL8));
		MaterialStd.Diffuse = white;
		MaterialStd.Ambient = black;
		MaterialStd.Specular = white;
		MaterialStd.Emissive = black;
		MaterialStd.Power = 0.0f;
	}

	VOID CleanManaged() {
		if (lpTexturaPovrch != NULL)
			lpTexturaPovrch->Release();
	}

	VOID CleanDefault() {
		if (lpMeshPovrch != NULL)
			lpMeshPovrch->Release();
		if (lpVBufferHorizont != NULL)
			lpVBufferHorizont->Release();
	}

	~Zeme() {
		CleanDefault();
		CleanManaged();
	}

	VOID Render(LPD3DXMATRIX pCameraPosition) {
	// polomer zeme 6378
	// ionosfera 100 km
	// ozonova vrstva 50 km
	// mraky 10 km

		D3DLIGHT8 light;
		pDevice->GetLight(0, &light);

		FLOAT Rz2 = Rz*Rz, Ra2 = Ra*Ra;
		FLOAT h = Rz - Ra;					// tloustka atmosfery

		D3DXVECTOR3 CPos, LPos, EPos;		// CPos - pozice kamery, LPos - pozice svetla, EPos - pozice Zeme
		
		CPos.x = pCameraPosition->_41;
		CPos.y = pCameraPosition->_42;
		CPos.z = pCameraPosition->_43;

		LPos.x = light.Position.x;
		LPos.y = light.Position.y;
		LPos.z = light.Position.z;

		EPos.x = Pozice.x;
		EPos.y = Pozice.y;
		EPos.z = Pozice.z;

		FLOAT Vm = D3DX_PI*0.5f;			// Minimalni uhel viditelnosti
		FLOAT Om = asinf(Rz/Ra);			// Minimalni uhel osvetleni
		FLOAT Vcm = D3DX_PI-Om;				// Minimalni uhel viditelne atmosfery pod horizontem Zeme

		FLOAT lpv = 0.001f;					// Prumerna linearni pruhlednost vzduchu

		FLOAT a, b;							// uhel alpha - uhel mezi kamerou, bodem atmosfery a stredem Zeme
											// uhel beta - uhel mezi zdrojem svetla, bodem atmosfery a stredem Zeme
		FLOAT g;							// uhel gamma - uhel mezi kamerou, bodem atmosfery a zdrojem svetla

		FLOAT ca, cb;						// cosiny uhlu alpha a beta
		FLOAT cg;							// cosinus uhlu gamma


		FLOAT x1, y1, z1;					// vektor smerujici od bodu atmosfery ke stredu Zeme
		FLOAT x2, y2, z2;					// vektor smerujici od bodu atmosfery ke kamere
		FLOAT x3, y3, z3;					// vektor smerujici od bodu atmosfery ke zdroji svetla

		
		D3DXVECTOR3 pp, qq, rr;				// pp - vektor smerujici od stredu Zeme ke kamere
											// qq - vektor kolmy na pp
											// rr - vektor kolmy na pp a qq
		D3DXVECTOR3 ii, jj, kk;				// jednotkove vektory vektoru pp, qq, rr
		D3DXVECTOR3 ll;						// jednotkovy vektor smerujici od stredu zeme k bodu atmosfery

		D3DXVECTOR3 A;						// stred kruznice

		FLOAT s, r;							// s - vzdalenost stredu kruznice od pocatku
											// r - polomer kruznice

		pp = CPos - EPos;

		qq.x = 1.0f;
		qq.y = 1.0f;
		qq.z = 1.0f;

		if (pp.x != 0) {
			qq.x = -(qq.y*pp.y + qq.z*pp.z)/pp.x;
		} else {
			if (pp.y != 0) {
				qq.y = -(qq.x*pp.x + qq.z*pp.z)/pp.y;
			} else {
				if (pp.z != 0) {
					qq.z = -(qq.x*pp.x + qq.y*pp.y)/pp.z;
				} else {
					//chyba
				}
			}
		}

		D3DXVec3Cross(&rr, &pp, &qq);
		D3DXVec3Normalize(&ii, &pp);
		D3DXVec3Normalize(&jj, &qq);
		D3DXVec3Normalize(&kk, &rr);

//		s = Rz2/(D3DXVec3Length(&pp)*1.04f);
		s = Rz2/(D3DXVec3Length(&pp));
		r = sqrtf(Rz2-s*s)*0.98f;


		A = ii*s;


		HorizontVertex* pVertices;

		lpVBufferHorizont->Lock(0, 0, (BYTE**)&pVertices, 0);

		DWORD NV = 64;
		FLOAT t = 0, krok = 2.0f*D3DX_PI/(FLOAT)(NV-1);
		for (DWORD j = 0; j < 2*NV; j += 2) {
			pVertices[j+1].pos = A + sinf(t)*r*jj + cosf(t)*r*kk;

			x1 = EPos.x - pVertices[j+1].pos.x;
			y1 = EPos.y - pVertices[j+1].pos.y;
			z1 = EPos.z - pVertices[j+1].pos.z;

			FLOAT v = 1.0f/sqrtf(x1*x1 + y1*y1 + z1*z1);
			ll.x = x1*v;
			ll.y = y1*v;
			ll.z = z1*v;
			pVertices[j].pos = pVertices[j+1].pos + ll*h;

			x2 = CPos.x - pVertices[j+1].pos.x;
			y2 = CPos.y - pVertices[j+1].pos.y;
			z2 = CPos.z - pVertices[j+1].pos.z;
			x3 = LPos.x - pVertices[j+1].pos.x;
			y3 = LPos.y - pVertices[j+1].pos.y;
			z3 = LPos.z - pVertices[j+1].pos.z;
			cg = (x2*x3 + y2*y3 + z2*z3)/sqrtf((x2*x2 + y2*y2 + z2*z2)*(x3*x3 + y3*y3 + z3*z3));
			g = acosf(cg);

			x3 = LPos.x - pVertices[j+1].pos.x;
			y3 = LPos.y - pVertices[j+1].pos.y;
			z3 = LPos.z - pVertices[j+1].pos.z;
			cb = (x1*x3 + y1*y3 + z1*z3)/sqrtf((x1*x1 + y1*y1 + z1*z1)*(x3*x3 + y3*y3 + z3*z3));
			b = acosf(cb);

			FLOAT sv;
	//		if (b >= Om) sv = -1.0f/(Om-D3DX_PI)*b + Om/(Om - D3DX_PI);
			if (b >= Om) sv = -1.0f/(Om-D3DX_PI-0.1f)*b + (Om-0.1f)/(Om-D3DX_PI-0.1f);
			else sv = 0.0f;

			FLOAT b = g/D3DX_PI;
			pVertices[j+1].color = D3DCOLOR_COLORVALUE(b*sv, b*sv, (1.0f-b)*sv, sv);
	//		pVertices[j].color = D3DCOLOR_COLORVALUE(b, b, 1.0f-b, 1.0f);
	//		pVertices[j+1].color = 0xff0000ff;
			pVertices[j].color = 0x00000000;
			t += krok;
		}

		lpVBufferHorizont->Unlock();



		struct TextMesh {
			FLOAT x, y, z;
			FLOAT nx, ny, nz;
			DWORD c;
			FLOAT tu, tv;
		};

		TextMesh *ptm;

		lpMeshPovrch->LockVertexBuffer(0, (BYTE **)&ptm);

		DWORD nv = lpMeshPovrch->GetNumVertices();
		for (DWORD i = 0; i < nv; i ++) {
			x1 = EPos.x - ptm[i].x;
			y1 = EPos.y - ptm[i].y;
			z1 = EPos.z - ptm[i].z;
			x2 = CPos.x - ptm[i].x;
			y2 = CPos.y - ptm[i].y;
			z2 = CPos.z - ptm[i].z;
			ca = (x1*x2 + y1*y2 + z1*z2)/sqrtf((x1*x1 + y1*y1 + z1*z1)*(x2*x2 + y2*y2 + z2*z2));
			a = acosf(ca);
			if (a >= Vm-0.1f) {
				x3 = LPos.x - ptm[i].x;
				y3 = LPos.y - ptm[i].y;
				z3 = LPos.z - ptm[i].z;
				cb = (x1*x3 + y1*y3 + z1*z3)/sqrtf((x1*x1 + y1*y1 + z1*z1)*(x3*x3 + y3*y3 + z3*z3));
				b = acosf(cb);
				if (b >= Om) {
						FLOAT c2 = ca*ca;
						FLOAT t = sqrtf(Ra2 - Rz2 + 2*Rz2*c2 - 2*sqrtf(Rz2*c2*(Ra2 - Rz2 + Rz2*c2)));
							// t - delka drahy paprsku atmosferou
						FLOAT p = powf(lpv, t);
							// p - pruhlednost
						cg = (x2*x3 + y2*y3 + z2*z3)/sqrtf((x2*x2 + y2*y2 + z2*z2)*(x3*x3 + y3*y3 + z3*z3));
						g = acosf(cg);
						FLOAT b = g/D3DX_PI;
						FLOAT cr = b, cg = b, cb = (1.0f-b);
						ptm[i].c = D3DCOLOR_COLORVALUE((1.0-cr)*p+cr, (1.0-cg)*p+cg, (1.0-cb)*p+cb, 1.0f-p);
	//					ptm[i].c = D3DCOLOR_COLORVALUE(1.0f-p, 1.0f-p, 1.0f, p);
	//					ptm[i].c = D3DCOLOR_RGBA(255, 255, 255, 0);
	//					ptm[i].c = D3DCOLOR_COLORVALUE(0.0f, 0.0f, 1.0f-0.5f*p, 1.0f-p);
				} else {
	//				ptm[i].c = D3DCOLOR_RGBA(0, 0, 200, 255);
					ptm[i].c = D3DCOLOR_RGBA(0, 0, 0, 255);
				}
			}
		}

		lpMeshPovrch->UnlockVertexBuffer();



		D3DXMATRIX matHelp;
		
		D3DXMatrixTranslation(&matHelp, Pozice.x, Pozice.y, Pozice.z);
		pDevice->SetTransform(D3DTS_WORLD, &matHelp);

		pDevice->SetRenderState(D3DRS_DITHERENABLE, TRUE);
		pDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
		pDevice->SetRenderState(D3DRS_ZENABLE, TRUE);
		pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);

		pDevice->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR);
		pDevice->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTEXF_LINEAR);
		pDevice->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_LINEAR);


		pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
		pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
		pDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
		pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE);

		pDevice->SetTextureStageState(0, D3DTSS_MIPMAPLODBIAS, MipMapBias);
		pDevice->SetRenderState(D3DRS_WRAP0, D3DWRAPCOORD_0);

		pDevice->SetMaterial(&MaterialStd);
		pDevice->SetTexture(0, lpTexturaPovrch);
		lpMeshPovrch->DrawSubset(0);

		pDevice->SetRenderState(D3DRS_DITHERENABLE, TRUE);
		pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
		pDevice->SetRenderState(D3DRS_ZENABLE, FALSE);
		pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);

		pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
		pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_DIFFUSE);
		pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
		pDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);

		pDevice->SetStreamSource(0, lpVBufferHorizont, sizeof(HorizontVertex));
		pDevice->SetVertexShader(D3DFVF_HORIZONT);
		pDevice->SetTexture(0, NULL);
		pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2*NV-2);

	}

};


class Kamera : public Objekt {
	LPDIRECT3DDEVICE8	pDevice;

public:
	D3DXMATRIX			matView;
	D3DXMATRIX			matProj;
	D3DXMATRIX			matCamRot;
	D3DXMATRIX			matCamTrn;

	FLOAT *persp, *pomer;

	Kamera(LPDIRECT3DDEVICE8 ipDevice, FLOAT *ipersp, FLOAT *ipomer) {
		pDevice = ipDevice;
		persp = ipersp;
		pomer = ipomer;

		LoadManaged();
		LoadDefault();
	}

	VOID LoadManaged() {
	}

	VOID LoadDefault() {
		D3DXMatrixPerspectiveFovLH(&matProj, (*persp), (*pomer), 0.01f, 10000.0f);
		pDevice->SetTransform(D3DTS_PROJECTION, &matProj);
	}

	VOID CleanManaged() {
	}

	VOID CleanDefault() {
	}

	VOID Zapni() {
//		D3DXMatrixRotationYawPitchRoll(&matCamRot, a, b, g);
//		D3DXMatrixTranslation(&matCamTrn, Pozice.x, Pozice.y, Pozice.z);
		D3DXMatrixMultiply(&matView, &matCamRot, &matCamTrn);
		D3DXMatrixInverse(&matView, NULL, &matView);

		pDevice->SetTransform(D3DTS_VIEW, &matView);
	}
};