#include <stdio.h>

struct SETUPINFO {
	UINT Adapter;
	UINT Mode;
	D3DDISPLAYMODE Display;
	D3DDISPLAYMODE ActualDisplay;
	BOOL FullScreen;
};

HWND hwnd_tlac1;
HWND hwnd_list1;
HWND hwnd_list2;
HWND hwnd_check1;
BOOL KonecSetup = FALSE;

D3DADAPTER_IDENTIFIER8 *d3dai8;
D3DDISPLAYMODE **dme;
D3DDISPLAYMODE d3ddmWindowed;
UINT noa, *nodm;

UINT aadap, amode;
BOOL afull;


HRESULT GetAdaptersAndModes() {
	LPDIRECT3D8 lpD3D = NULL;
	UINT mode;
	UINT adapt;

	if (NULL == (lpD3D = Direct3DCreate8(D3D_SDK_VERSION))) {
		MessageBox(NULL, "Nelze inicializovat Direct3D", TEXT("Setup"), MB_ICONERROR);
		return E_FAIL;
	}

	noa = lpD3D->GetAdapterCount();
	d3dai8 = new D3DADAPTER_IDENTIFIER8[noa];
	for (adapt = 0; adapt < noa; adapt ++) {
		if(lpD3D->GetAdapterIdentifier(adapt, 0, &d3dai8[adapt]) != D3D_OK) {
			MessageBox(NULL, "Nelze zjistit grafick adaptry", TEXT("Setup"), MB_ICONERROR);
			return E_FAIL;
		}
	}


	dme = new D3DDISPLAYMODE*[noa];
	nodm = new UINT[noa];

	for (adapt = 0; adapt < noa; adapt ++) {
		nodm[adapt] = lpD3D->GetAdapterModeCount(adapt);
		dme[adapt] = new D3DDISPLAYMODE[nodm[adapt]];
		for (mode = 0; mode < nodm[adapt]; mode ++) {
			if (lpD3D->EnumAdapterModes(adapt, mode, &dme[adapt][mode]) != D3D_OK) {
				MessageBox(NULL, "Nelze zjistit grafick mdy", TEXT("Setup"), MB_ICONERROR);
				return E_FAIL;
			}
		}
	}

	if (FAILED(lpD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddmWindowed)))
		return E_FAIL;

	if (lpD3D != NULL)
	lpD3D->Release();

	return S_OK;
}


VOID FillModeList(UINT Adapter) {
	char mody[50];
	char *form;
	UINT mode;
	for (mode = 0; mode < nodm[Adapter]; mode ++) {
		if (dme[Adapter][mode].Format == D3DFMT_X1R5G5B5) form = "16bit - X1R5G5B5";
		if (dme[Adapter][mode].Format == D3DFMT_R5G6B5) form = "16bit - R5G6B5";
		if (dme[Adapter][mode].Format == D3DFMT_X8R8G8B8) form = "32bit - X8R8G8B8";
		if (dme[Adapter][mode].Format == D3DFMT_A8R8G8B8) form = "32bit - A8R8G8B8";

		sprintf(mody, "%d x %d, %s", dme[Adapter][mode].Width, dme[Adapter][mode].Height, form);
		SendMessage(hwnd_list1, CB_ADDSTRING, 0, (LPARAM)mody);
	}
	SendMessage(hwnd_list1, CB_SETCURSEL, (WPARAM)amode, 0);
}

VOID FillAdapterList() {
	UINT adapt;
	for (adapt = 0; adapt < noa; adapt ++) {
		SendMessage(hwnd_list2, CB_ADDSTRING, 0, (LPARAM)d3dai8[adapt].Description);
	}
	SendMessage(hwnd_list2, CB_SETCURSEL, (WPARAM)aadap, 0);
}

/*
INT_PTR CALLBACK DlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
  switch ( uMsg )
  {
    case WM_COMMAND:
      switch ( LOWORD(wParam) )
      {
        case IDOK:
          EndDialog(hwndDlg, IDOK);
          break;
        case IDCANCEL:
          EndDialog(hwndDlg, IDCANCEL);
          break;
      }
      break;
  }
  return FALSE;
}
*/
LRESULT CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {

	case WM_COMMAND:
		if (lParam == (LPARAM)hwnd_tlac1) {
			KonecSetup = TRUE;
		}
		if (lParam == (LPARAM)hwnd_list2) {
			int count = SendMessage(hwnd_list2, CB_GETCURSEL, 0, 0);
			if ((UINT)count != aadap) {
				SendMessage(hwnd_list1, CB_RESETCONTENT, 0, 0);
				FillModeList(count);
				aadap = count;
			}
		}
		if (lParam == (LPARAM)hwnd_list1) {
			int count = SendMessage(hwnd_list1, CB_GETCURSEL, 0, 0);
			if ((UINT)count != amode) {
				amode = count;
			}
		}

		if (lParam == (LPARAM)hwnd_check1) {
			afull = !afull;
		}

		break;

	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

BOOL Setup(HINSTANCE hInstance, SETUPINFO *si) {

	if (GetAdaptersAndModes() != S_OK)
		return FALSE;

	INT posx = 100, posy = 100, rozx = 250, rozy = 200;

	HWND hwnd;

	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance = hInstance;
	wc.lpfnWndProc = DlgProc;
	wc.lpszClassName = TEXT("Setup");
	wc.lpszMenuName = NULL;
	wc.style = CS_HREDRAW | CS_VREDRAW;

	if (!RegisterClassEx(&wc)) return FALSE;

	hwnd = CreateWindowEx(
		0,
		TEXT("Setup"),
		TEXT("Setup"),
		WS_DLGFRAME | WS_VISIBLE,
		posx, posy, rozx, rozy,
		NULL,
		NULL,
		hInstance,
		NULL);

	if (!hwnd) return FALSE;

	hwnd_tlac1 = CreateWindowEx(
		0,
		TEXT("BUTTON"),
		TEXT("Spus"),
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		50, rozy-60, rozx-100, 25,
		hwnd,
		NULL,
		hInstance,
		NULL);

	hwnd_list1 = CreateWindowEx(
		0,
		TEXT("ComboBox"),
		TEXT("Rozliseni"),
		WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | CBS_AUTOHSCROLL | WS_VSCROLL | CBS_AUTOHSCROLL,
		10, 35, rozx-20, 250,
		hwnd,
		NULL,
		hInstance,
		NULL);

	hwnd_list2 = CreateWindowEx(
		0,
		TEXT("ComboBox"),
		TEXT("Adaptery"),
		WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | CBS_AUTOHSCROLL | WS_VSCROLL | CBS_AUTOHSCROLL,
		10, 10, rozx-20, 250,
		hwnd,
		NULL,
		hInstance,
		NULL);

	hwnd_check1 = CreateWindowEx(
		0,
		TEXT("BUTTON"),
		TEXT("FullScreen"),
		WS_CHILD | WS_VISIBLE | BS_CHECKBOX | BS_AUTOCHECKBOX,
		10, 60, rozx-20, 25,
		hwnd,
		NULL,
		hInstance,
		NULL);

	HFONT hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	SendMessage(hwnd_list1, WM_SETFONT, (WPARAM)hFont, (LPARAM)TRUE);
	SendMessage(hwnd_list2, WM_SETFONT, (WPARAM)hFont, (LPARAM)TRUE);
	SetFocus(hwnd_tlac1);


	aadap = D3DADAPTER_DEFAULT;
	amode = 5;
	afull = FALSE;

	FillAdapterList();
	FillModeList(aadap);

	MSG msg;
	while (!KonecSetup) {
		if (GetMessage(&msg, NULL, 0, 0)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	DestroyWindow(hwnd);

	si->Adapter = aadap;
	si->Mode = amode;
	si->Display = dme[aadap][amode];
	si->FullScreen = afull;
	si->ActualDisplay = d3ddmWindowed;

	delete[] d3dai8;
	for (UINT adapt = 0; adapt < noa; adapt ++) {
		delete[] dme[adapt];
	}

	return TRUE;
}